/*
**************************************
*       INEL 4206 - Micro I          *
*        Problem Set 3               *
*     Due on : April 15, 2003        *
*    University of Puerto Rico       *
*        Mayaguez Campus             *
*    Prepared by: Armando Marin      *
************************************** 
* Filename: p2.c                     *
* Descpription:                      *
*   C example file for problem 2     *
*                                    *
************************************** 
*/
#include<stdio.h>


/* Declaration of global variable */
int N = 4; /* Test polynomial has N terms */

/* Array of polynomial coefficients */
int polynomial[5]={3,4,6,8,1};

/* Forward declaration of solve and power procedure */
int solve(int x, int poly[], int n);

int power(int x, int y);

/* Definition of main procedure */
int main(void){
  /* Declaration and initialization of local variables x and result */
  int x = 3;
  printf("Result = %d \n", solve(x, polynomial, N));
}
  
/* Definition of solve procedure */
int solve(int x, int poly[], int n){
  int result = 0 ;
  int i=0;
  /* For each term in the polynomial, calculate power of X for
     corresponding index, multiply by coefficient and add to result */
  for(i=0; i<=n ; i++){
    /* multiply exp by polynomial coefficient of index i */
    result = result + power(x,i) * poly[i];
  }
  return result;
}

int power(int x, int y) {
  /* Set result equal to X */
  int  result = 1;
  int i =0;
  /* Loop Y  times */
  for(i=0; i<y; i++){
    /* Multiply result by X (increase of X stored in result) */
    result=result * x;
  }
  return result;
}


