######################################
#       INEL 4206 - Micro I          #
#        Problem Set 3               #
#     Due on : April 15, 2003        #
#    University of Puerto Rico       #
#        Mayaguez Campus             #
#    Prepared by: Armando Marin      #
###################################### 
# Filename: p3.asm                   #
# Descpription:                      #
#   assembly template for problem 3  #
#                                    #
###################################### 
#                                    #
# Name:	                             #
# Student#:	                     #
# Amadeus acc:	                     #
#                                    #
######################################

	
	.data
N:	.word 4

polynomial: .word 3
	.word 4
	.word 6
	.word 8
	.word 1

res:	.asciiz "Result ="
nl:	.asciiz "\n"

	.globl main
	.text

main:
	#Prepare Stack for main function execution
	sub	$sp, $sp, 16		#Increase Stack Space by 16 bytes
	sw	$a0, 0($sp)		#Store a0
	sw	$ra, 4($sp)		#Store ra
	sw	$s0, 8($sp)		#Store S0
	sw	$s1, 12($sp)		#Store S1

	la	$s0, polynomial		#Load address of polynomial array
	li	$t1, 3			#int x=3
	la	$t2, N			#load N into $t2
	lw	$t2, 0($t2)

	
	move	$a0, $t1		#load x as first argument

	move	$a1, $t2		#load N as second argument
	
	li	$a2, 0			#load a 0 as i for first call
					#to horner

	move	$a3, $s0		#load address of polynomial as
					#fourth argument
	
	jal	horner			#call horner function
	
	move	$s1, $v0		#copy return value into s1
	
	la	$a0, res		#Print "Result ="
	li	$v0, 4
	syscall
	
	move	$a0, $s1		#Print result value
	li	$v0, 1
	syscall

	la	$a0, nl			#Print new line
	li	$v0, 4
	syscall

	lw	$a0, 0($sp)		#Pop Stack
	lw	$ra, 4($sp)
	lw	$s0, 8($sp)
	lw	$s1, 12($sp)
	addu	$sp, $sp, 16

	jr	$ra


	
horner:
#Start your code here